<!DOCTYPE html>
<html lang="en">

<head>
    <title>Thêm User</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container jumbotron">
        <h1>Chi tiết user</h1>
        <div class=" row mb-2">
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">First Name</label>
            </div>
            <div class="col-sm-10">
                <input id="first-name" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Last name</label>
            </div>
            <div class="col-sm-10">
                <input id="last-name" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Subject</label>
            </div>
            <div class="col-sm-10">
                <input id="subject" class="form-control mb-2" type="text" placeholder="...">
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Country</label>
            </div>
            <div class="col-sm-10">
                <select id="country" class="form-control mb-2" name="" id="">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-2">
                <label for="">Customer Type</label>
            </div>
            <div class="col-sm-10">
                <select id="cus-type" class="form-control mb-2" name="" id="">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>

        <!--hai nut  -->
        <div class="row">
            <div class="col-sm-6">
                <button id="btn-insert" class="btn btn-success form-control">Insert user</button>
            </div>
            <div class="col-sm-6">
                <button id="btn-huy-bo" class="btn btn-success form-control">Hủy bỏ</button>
            </div>
        </div>
    </div>
</body>
<script>
    
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
       
        // khai báo nút insert 
        $("#btn-insert").on("click", onInsertClick);
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onInsertClick(){
        console.log("đã ấn nút insert ");
         // khai báo object lưu trữ 
         var vObjectUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "New"
        }
       // step 1;  collect data
        getCollectData(vObjectUser);
         // step 2; validate data  
         var vResult = getValidateData(vObjectUser);
         // step 3 : get api 
        if (vResult) {
            console.log("kiểm tra dữ liệu đạt yêu cầu ");
            getInsertUser(vObjectUser)
        }
       
        // step 4 : display 
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // khai  báo hàm thu thập dữ liệu
    function getCollectData(paramObject) {
        paramObject.firstname = $("#first-name").val().trim();
        paramObject.lastname = $("#last-name").val().trim();
        paramObject.country = $("#country").val().trim();
        paramObject.subject = $("#subject").val();
        paramObject.customerType = $("#cus-type").val();
    }
     // khai báo hàm kiểm tra dữ liệu 
     function getValidateData(paramObject) {
        if (paramObject.firstname == "") {
            alert("firstname không được để trống ");
            return false;
        }
        if (paramObject.lastname == "") {
            alert("lastname không được để trống ");
            return false;
        }
        if (paramObject.country == "") {
            alert("country không được để trống ");
            return false;
        }
        if (paramObject.subject == null) {
            alert("subject không được để trống ");
            return false;
        }
        if (paramObject.customerType == null) {
            alert("customerType không được để trống ");
            return false;
        }
        return true;
    }

     // Mẫu gọi API cho bài 33.30 - Insert user (thêm user)
     function getInsertUser(paramObject) {
        //data to be sent 
        $.ajax({
            url:"http://203.171.20.210:8080/crud-api/users/",
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(paramObject),
            success: getInsertThanhCong,
            error: getInsertKhongThanhCong
        });
    }
    // them thanh cong
    function getInsertThanhCong(paramRes){
        console.log(paramRes);
        alert(" đã  thêm thành công ");
        window.location.href = "task32-50.html";
    }
    // them không thành công 
    function getInsertKhongThanhCong(){
        alert("thêm không thành công ");
        window.location.href = "task32-50.html";
    }
</script>

</html>